unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TMainF = class(TForm)
    Lengthin: TEdit;
    torquein: TEdit;
    LengL: TLabel;
    torqueL: TLabel;
    GdataL: TLabel;
    Gdatain: TEdit;
    ComboBox: TComboBox;
    Label1: TLabel;
    DiaCalcB: TButton;
    abcalc: TBitBtn;
    diaL: TLabel;
    diaLd1: TLabel;
    Diain: TEdit;
    diaind1: TEdit;
    Label2: TLabel;
    asize: TLabel;
    bsize: TLabel;
    asizein: TEdit;
    bsizein: TEdit;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure abcalcClick(Sender: TObject);
    procedure DiaCalcBClick(Sender: TObject);
    procedure ComboBoxChange(Sender: TObject);
    procedure GdatainKeyPress(Sender: TObject; var Key: Char);
    procedure LengthinChange(Sender: TObject);
    procedure torqueinChange(Sender: TObject);
    procedure GdatainChange(Sender: TObject);
    procedure DiainChange(Sender: TObject);
    procedure diaind1Change(Sender: TObject);
    procedure asizeinChange(Sender: TObject);
    procedure bsizeinChange(Sender: TObject);
  private
    { Private 錾 }
    procedure clear;
    procedure disp;
    procedure ItemAdd;
    function  FloatCheck(indat: string): integer;
    procedure MessDisp;//Rg\
    procedure KDisp;//W\
  public
    { Public 錾 }
  end;

var
  MainF: TMainF;

  T:    Double;             // gN
  L:    Double;             // 
  d1,d2:    Double;         // a
  G:    Double;             // eW
  sQ:   Double;             // ˂p
  tau:  Double;             // f
  aleng:    Double;         // a@
  bleng:    Double;         // b@
  Yscale, Xscale:  double;
  K2D,K3D,X1:    Double;    // lp`fʌW
  Xpos,Ypos:  integer;      // OtBbNp|WV

  Itemstr: array[0..7] of string = ('|','d|','XeX','','A~','iC','|AZ','|J');   // ގ
  ItemG:  array[0..7] of string = ('83000','84000','70000','35000','26000','1000','1400','11000');                // eW

  K2:   array[0..33] of Double = (0.1406, 0.1474, 0.1540, 0.1602, 0.1661, 0.1717, 0.1771, 0.1821,       // `̃lWCW K2
                                  0.1869, 0.1914, 0.1958, 0.2037, 0.2109, 0.2143, 0.2174, 0.2233,
                                  0.2287, 0.2401, 0.2494, 0.2570, 0.2633, 0.2733, 0.2808, 0.2866,
                                  0.2914, 0.2983, 0.3033, 0.3071, 0.3100, 0.3123, 0.3228, 0.3291,
                                  0.3312, 0.3333);
  K3:   array[0..33] of Double = (0.2082, 0.2112, 0.2139, 0.2165, 0.2189, 0.2212, 0.2236, 0.2254,       // `̃lWCW K3
                                  0.2273, 0.2289, 0.2310, 0.2343, 0.2375, 0.2390, 0.2404, 0.2432,
                                  0.2459, 0.2520, 0.2576, 0.2626, 0.2672, 0.2751, 0.2817, 0.2870,
                                  0.2915, 0.2984, 0.3033, 0.3071, 0.3100, 0.3123, 0.3228, 0.3292,
                                  0.3312, 0.3333);
  K1:   array[0..33] of Double = (0.6753, 0.6979, 0.7200, 0.7400, 0.7588, 0.7762, 0.7920, 0.8079,
                                  0.8223, 0.8362, 0.8476, 0.8694, 0.8880, 0.8966, 0.9043, 0.9182,
                                  0.9300, 0.9523, 0.9682, 0.9787, 0.9854, 0.9935, 0.9968, 0.9986,
                                  0.9997, 0.9997, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
                                  1.0000, 1.0000);

  ba:   array[0..33] of Double = (1,   1.05, 1.1, 1.15, 1.2, 1.25, 1.3, 1.35,                           // `̃lWCW c
                                  1.4, 1.45, 1.5, 1.6,  1.7, 1.75, 1.8, 1.9,
                                  2,   2.25, 2.5, 2.75, 3,   3.5,  4,   4.5,
                                  5,   6,    7,   8,    9,   10,   20,  50,
                                  100, 10E20);

  K4:   array[0..12] of Double = (1.0000, 0.9160, 0.8590, 0.8418, 0.8207, 0.7951, 0.7663, 0.7500,       // 0.7500͐l
                                  0.7447, 0.7430, 0.7426, 0.7427, 0.7431);
  k4ba: array[0..12] of Double = (1,   1.25, 1.5, 1.6,  1.75, 2,   2.5, 3.2,                            // 3.2 ͐ǉl
                                   4,  5,   8,   10,    20);
{K1 yс@k4 ̒ĺAł̌vZɂ͎gpȂ}

const
    Ytop = 200;
    Xtop = 500;
    Ybase = 420;
    Xbase = 100;
    Yposd = 30;
    ndata = 7;      // ގf[^[@-1

implementation

uses Math;

{$R *.dfm}
var
  dispF: boolean;

procedure TMainF.KDisp; // `̃lWWOt\
var
  KK: integer;
  Kmax:   integer;
begin
  Kmax := 30;
  clear;
  disp;
  Xscale := Xtop / Ba[Kmax];
  Yscale := Ytop / 0.4;
  with Image1.Canvas do begin
    Font.Color := clRed;
    Textout(Xbase + 50,Ybase - Ytop,'ԁ@jQ');
    Font.Color := clBlue;
    Textout(Xbase + 50,Ybase - Ytop + 15,'@jR');
    if dispF = False then begin
      Font.Color := clGreen;
      Textout(Xbase + 50,Ybase - Ytop + 30,'΁@jP');
      Font.Color := clLime;
      Textout(Xbase + 50,Ybase - Ytop + 45,'΁@jS');
    end;
    Font.Color := clBlack;
    Textout(Xbase + 50,Ybase + 20,'b / a');
    Pen.Color := clBlack;
// k2,k3
    Pen.Width := 1;
    Pen.Style := psSolid;
    MoveTo(Xbase,Ybase - Ytop);
    LineTo(Xbase,Ybase);
    LineTo(Xbase + Xtop,Ybase);
    if dispF = False then begin                             // vZ͕\Ȃ
// K1XP[
      Pen.Color := clGreen;
      MoveTo(Xbase + Xtop,Ybase - Ytop);
      LineTo(Xbase + Xtop,Ybase);
    end;
// K2
    Pen.Color := clRed;
    Pen.Width := 2;
    Xpos := round(Xscale * ba[0]) + Xbase;
    Ypos := Ybase - round(Yscale * K2[0]);
    MoveTo(Xpos, Ypos);
    for KK := 1 to Kmax do
      begin
        Xpos := round(Xscale * ba[KK]) + Xbase;
        Ypos := Ybase - round(Yscale * K2[KK]);
        LineTo(Xpos, Ypos);
      end;
// k3
    Pen.Color := clBlue;
    Pen.Width := 2;
    Xpos := round(Xscale * ba[0]) + Xbase;
    Ypos := Ybase - round(Yscale * K3[0]);
    MoveTo(Xpos, Ypos);
    for KK := 1 to Kmax do
      begin
        Xpos := round(Xscale * ba[KK]) + Xbase;
        Ypos := Ybase - round(Yscale * K3[KK]);
        LineTo(Xpos, Ypos);
      end;
    if dispF = False then begin                             // vZ͕\Ȃ
// k1
      Yscale := Ytop / 0.4;
      Pen.Color := clGreen;
      Pen.Width := 2;
      Xpos := round(Xscale * ba[0]) + Xbase;
      Ypos := Ybase - round(Yscale * (K1[0] - 0.6));
      MoveTo(Xpos, Ypos);
      for KK := 1 to Kmax do
        begin
          Xpos := round(Xscale * ba[KK]) + Xbase;
          Ypos := Ybase - round(Yscale * (K1[KK] - 0.6));
          LineTo(Xpos, Ypos);
        end;
// k4
      Pen.Color := clLime;
      Pen.Width := 1;
      Xpos := round(Xscale * ba[0]) + Xbase;
      Ypos := Ybase - round(Yscale * (K4Ba[0] - 0.6));
      MoveTo(Xpos, Ypos);
      for KK := 1 to 12 do
        begin
          Xpos := round(Xscale * K4ba[KK]) + Xbase;
          Ypos := Ybase - round(Yscale * (K4[KK] - 0.6));
          LineTo(Xpos, Ypos);
        end;
    end;
//
    Yscale := Ytop / 0.4;
    Pen.Color := clBlack;
    Pen.Width := 1;
// k2,k3  c⏕Obh
    for KK := 1 to 4 do
      begin
        Ypos := Ybase - round(Yscale * KK * 0.1);
        MoveTo(Xbase,Ypos);
        LineTo(Xbase + 5,Ypos);
        Textout(Xbase-20,Ypos - 5,FloatTostr(KK * 0.1));
      end;
    if dispF = False then begin                             // vZ͕\Ȃ
// k1 c ⏕Obh
      Pen.Color := clGreen;
      Font.Color := clGreen;
      for KK := 6 to 10 do
        begin
          Ypos := Ybase - round(Yscale * (KK -6) * 0.1);
          MoveTo(Xbase + Xtop,Ypos);
          LineTo(Xbase - 5 + Xtop,Ypos);
          Textout(Xbase + 10 + Xtop,Ypos - 5,FloatTostr(KK * 0.1));
        end;
    end;
// w Obh
    Font.Color := clBlack;
    for KK := 1 to round(Ba[Kmax]) do
      begin
        Xpos := round(Xscale * KK) + Xbase;
        MoveTo(Xpos,Ybase);
        LineTo(Xpos,Ybase - 5);
        Textout(Xpos - Textwidth(intTostr(KK)) div 2,Ybase + 3,intTostr(KK));
      end;
  end;
end;

procedure TMainF.MessDisp;//Rg\
var
    L:  integer;
const
    Ybase = 80;
begin
  with Image1.Canvas do begin
    Font.Height := 15;
    Font.Color := clBlue;
    TextOut(30,180 + Ybase,'***************************************************************');
    Font.Color := ClBlack;
    TextOut(30,200 + Ybase,'f[^[̓');
    Font.Height := 14;
    Font.Color := clMaroon;
    TextOut(40,215 + Ybase,'PDg[Vo[̒');
    TextOut(40,230 + Ybase,'QDg[Vo[ɗ^gN');
    TextOut(40,245 + Ybase,'RDg[Vo[̉eW');
    TextOut(40,260 + Ybase,'    ގ̑IĉeW͏o܂B');
    TextOut(40,275 + Ybase,'    ގXgɖꍇ́AeW̒l͂ĂB');
    TextOut(40,290 + Ybase,'SDfʌ`̒l͂܂B');
    TextOut(40,305 + Ybase,'@@ێ̏ꍇ́AaɂO([)͂܂B');
    TextOut(40,320 + Ybase,'TDvZ{^NbN܂B');
    TextOut(40,335 + Ybase,'@@͂ꂪΌvZʂo܂B');
    Font.Color := clBlue;
    TextOut(350,215 + Ybase,'Pʂ mm');
    TextOut(350,230 + Ybase,'Pʂ Nmm');
    TextOut(350,245 + Ybase,'Pʂ Nmm');
    TextOut(350,290 + Ybase,'Pʂ mm');
    L := TextWidth('Pʂ Nmm');
    Font.Height := 10;
    TextOut(350 + L,243 + Ybase,'2');
  end;
end;

function  TMainF.FloatCheck(indat: string): integer;    // s_͂`FbN
var                                                     // Val(Text, V, check); gp΂̃[`͕KvȂ
  Ls,din,II:integer;                                    // ̃[`ł́h|h}CiX̓͂G[ɃZbg
  chchar: char;                                         // SĂ̓͂Ƀ}CiX͖
begin
  Ls := Length(indat);                                  // ̒
  if Ls = 0 then                                        // ̒ 0@Ȃ
    begin
      Result := 1;                                      // P Zbg߂
      exit;
    end;
  din := 0;
  for II := 1 to Ls do                                  // PmF
    begin
      chchar := indat[II];
      case chchar of
        '0'..'9':;                                      // '0' .. '9'
             '.':inc(din);                              // _̐
            else
            begin                                       // 3 Zbg
              Result := 3;
              exit;                                     // '0'..'9''.'ȊOȂI
            end;
        end;
    end;
  if din > 1 then Result := 2                           // gp_̐P傫߂lQZbg
             else Result := 0;                          // [Zbg
end;

procedure TMainF.ItemAdd;
var
  II: integer;
  StringList: TStrings;
begin
  StringList := TStringList.Create;   // Xg^z錾
  StringList.Clear;
  try
    for II := 0 to ndata do StringList.Add(Itemstr[II]);      // Xgɍޗzǉ
    ComboBox.Items := StringList;                             // R{{bNXɃXgǉ
  finally
    StringList.free;                  // Xg^zj
  end;
end;

procedure TMainF.disp;                // ʂɊG\
begin
  with Image1.Canvas do begin
    Font.Color := clBlue;
    Font.Height := 15;
    Textout(100,3,'@g[Vo[̂˂pvZ@     Makoic.inc');
    Font.Color := clFuchsia;
    Font.Color := clFuchsia;
    Font.Height := 12;
    Pen.Color := clRed;
    Pen.Width := 1;
// 
    Pen.Style := psSolid;
    Rectangle(80, 11 + Yposd, 80 + 81, 11 + 15 + Yposd);
    Pen.Color := clBlack;
    MoveTo(80,27 + Yposd);
    LineTo(80,42 + Yposd);
    MoveTo(80 + 80, 27 + Yposd);
    LineTo(80 + 80, 42 + Yposd);
    MoveTo(80,37 + Yposd);
    LineTo(80 + 80 , 37 + Yposd);
    MoveTo(87,34 + Yposd);
    LineTo(80 , 37 + Yposd);
    LineTo(87 , 40 + Yposd);
    MoveTo(160 - 7, 34 + Yposd);
    LineTo(160 , 37 + Yposd);
    LineTo(160 - 7 , 40 + Yposd);
    Textout(117,33 + Yposd,'L');
    Pen.Color := clBlue;
    Pen.Style := psDashDot;
    MoveTo(75,11 + 7 + Yposd);
    LineTo(80 + 81 + 5,11 + 7 + Yposd);
// Oa
    Pen.Style := psSolid;
    Pen.Color := clRed;
    Ellipse(310 - 15, 25 - 15 + Yposd, 310 + 15, 25 + 15 + Yposd);
// a
    Ellipse(310 - 10, 25 - 10 + Yposd, 310 + 10, 25 + 10 + Yposd);
// Oa@
    Pen.Color := clBlack;
    MoveTo(315,9 + Yposd);
    LineTo(360,9 + Yposd);
    MoveTo(315,40 + Yposd);
    LineTo(360,40 + Yposd);
    MoveTo(355,9 + Yposd);
    LineTo(355,40 + Yposd);
    MoveTo(352,16 + Yposd);
    LineTo(355,9 + Yposd);
    LineTo(358,17 + Yposd);
    MoveTo(352,33 + Yposd);
    LineTo(355,40 + Yposd);
    LineTo(358,32 + Yposd);
    Pen.Color := clRed;
    Textout(352,20 + Yposd,'d2');
// a@
    Pen.Color := clBlack;
    MoveTo(315,14 + Yposd);
    LineTo(345,14 + Yposd);
    MoveTo(315,35 + Yposd);
    LineTo(345,35 + Yposd);
    MoveTo(340,14 + Yposd);
    LineTo(340,35 + Yposd);
    MoveTo(337,21 + Yposd);
    LineTo(340,14 + Yposd);
    LineTo(343,22 + Yposd);
    MoveTo(337,28 + Yposd);
    LineTo(340,35 + Yposd);
    LineTo(343,27 + Yposd);
    Pen.Color := clRed;
    Textout(337,20 + Yposd,'d1');
    Pen.Color := clBlue;
    Pen.Style := psDashDot;
    MoveTo(310 - 20,25 + Yposd);
    LineTo(310 + 20,25 + Yposd);
    MoveTo(310,25 - 20 + Yposd);
    LineTo(310,25 + 20 + Yposd);
// lp
    Pen.Style := psSolid;
    Pen.Color := clRed;
    Rectangle(510, 9 - 4 + Yposd, 510 + 51, 9 + 20 - 4 + Yposd);
    Pen.Color := clBlack;
    MoveTo(510,31 - 4 + Yposd);
    LineTo(510,45 - 4 + Yposd);
    MoveTo(510 + 50, 31 - 4 + Yposd);
    LineTo(510 + 50, 45 - 4 + Yposd);
    MoveTo(510, 40 - 4 + Yposd);
    LineTo(510 + 50, 40 - 4 + Yposd);
    MoveTo(517, 37 - 4 + Yposd);
    LineTo(510, 40 - 4 + Yposd);
    LineTo(517, 43 - 4 + Yposd);
    MoveTo(503 + 50, 37 - 4 + Yposd);
    LineTo(510 + 50, 40 - 4 + Yposd);
    LineTo(503 + 50, 43 - 4 + Yposd);
    Textout(532,33 - 4 + Yposd,'a');
    MoveTo(563, 9 - 4 + Yposd);
    LineTo(590, 9 - 4 + Yposd);
    MoveTo(563, 9 + 20 - 4 + Yposd);
    LineTo(590, 9 + 20 - 4 + Yposd);
    MoveTo(585, 9 - 4 + Yposd);
    LineTo(585, 9 + 20 - 4 + Yposd);
    MoveTo(582, 9 - 4 + 7 + Yposd);
    LineTo(585, 9 - 4 + Yposd);
    LineTo(588, 9 - 4 + 7 + Yposd);
    MoveTo(582, 9 - 4 + 20 - 7 + Yposd);
    LineTo(585, 9 - 4 + 20 + Yposd);
    LineTo(588, 9 - 4 + 20 - 7 + Yposd);
    Textout(583,14 - 4 + Yposd,'b');
    Pen.Color := clBlue;
    Pen.Style := psDashDot;
    MoveTo(510 + 25 - 35,15 + Yposd);
    LineTo(510 + 25 + 35,15 + Yposd);
    MoveTo(510 + 25,15 - 20 + Yposd);
    LineTo(510 + 25,15 + 20 + Yposd);
  end;
end;

procedure TMainF.clear;
var
  NewRectL: TRect;
begin
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.Brush.Style := BsSolid;
  NewRectL := Rect(0, 0, ClientWidth, ClientHeight);
  Image1.Canvas.FillRect(NewRectL);
end;

procedure TMainF.FormCreate(Sender: TObject);
var
  Bitmap: TBitmap;
begin
  Width := 640;
  Height := 480;
  top := (Screen.Height - Height) div 2;
  left := (Screen.Width - width) div 2;
  Bitmap := TBitmap.Create;
  Bitmap.Width := ClientWidth;
  Bitmap.height:= ClientHeight;
  Image1.Picture.Graphic := Bitmap;
  Image1.Canvas.Font.Name := 'lr SVbN';
  Bitmap.Free;
  asize.Top := 50 + Yposd;
  bsize.Top := 80 + Yposd;
  asize.Left := 470;
  bsize.Left := 470;
  asize.Font.Height := 15;
  bsize.Font.Height := 15;
  asizein.Top := 50 + Yposd;
  bsizein.Top := 80 + Yposd;
  asizein.Left := 536;
  bsizein.Left := 536;
  asizein.Font.Height := 15;
  bsizein.Font.Height := 15;
  abcalc.Top := 110 + Yposd;
  abcalc.Left := 500;
  abcalc.Height := 25;
  abcalc.Width := 75;
  abcalc.Font.Height := 15;
  LengL.Top := 50 + Yposd;
  LengL.Left := 32;
  LengL.Font.Height := 15;
  Lengthin.Top := 50 + Yposd;
  Lengthin.Left := 80;
  Lengthin.Width := 80;
  Lengthin.Font.Height := 15;
  DiaL.Top := 52 + Yposd;
  DiaL.Left := 235;
  DiaL.Font.Height := 15;
  diaLd1.Top := 82 + Yposd;
  diaLd1.Left := 235;
  diaLd1.Font.Height := 15;
  Diain.Top := 50 + Yposd;
  Diain.Left := 300;
  Diain.Width := 75;
  Diain.Font.Height := 15;
  Diaind1.Top := 80 + Yposd;
  Diaind1.Left := 300;
  Diaind1.Width := 75;
  Diaind1.Font.Height := 15;
  diaCalcB.Top := 110 + Yposd;
  diaCalcB.Left := 300;
  diaCalcB.Width := 75;
  diaCalcB.Height := 25;
  diaCalcB.Font.Height := 15;
  torqueL.Top := 80 + Yposd;
  torqueL.Left := 32;
  torqueL.Font.Height := 15;
  torquein.Top := 100 + Yposd;
  torquein.Left := 80;
  torquein.Width := 80;
  torquein.Font.Height := 15;
  GdataL.Top := 125 + Yposd;
  GdataL.Left := 32;
  GdataL.Font.Height := 15;
  Gdatain.Top := 144 + Yposd;
  Gdatain.Left := 80;
  Gdatain.Width := 80;
  Gdatain.Font.Height := 15;
  Label1.Top := 125 + Yposd;
  Label1.Left := 176;
  Label1.Font.Height := 15;
  ComboBox.Top := 144 + Yposd;
  ComboBox.Left := 176;
  ComboBox.Height := 20;
  ComboBox.Width := 90;
  Label2.Top := 15 + Yposd;
  Label2.Left := 450;
  Label2.Font.Height := 14;
  clear;
  disp;
  ItemAdd;
  MessDisp;//Rg\
end;

procedure TMainF.Image1Click(Sender: TObject);
const
  Ycont = 200;
begin
  T := 32;
  L := 870;
  G := 70000;
  d2 := 8;
  clear;
  disp;
  with Image1.Canvas do begin
    Font.Height := 15;
    Font.Color:= Clred;
    TextOut(30, Ycont,'eXgvZ');
    sQ:= 32 * T * L / pi / power(d2, 4) / G;         // lWpvZ
    tau:= sQ * d2 * G / 2 / L;                       // f

    TextOut(50,20 + Ycont,'@@@' + floatTostr(L) + ' mm');
    TextOut(50,40 + Ycont,'a@@@' + floatTostr(d2) + ' mm');
    TextOut(50,60 + Ycont,'eW' + floatTostr(G) + ' Nmm^2');

    TextOut(50,80 + Ycont,'݊p@' + floatTostr(sQ) + ' rad');
    TextOut(50,100 + Ycont,'~@' + floatTostr(sQ * d2 / 2) + ' mm');
    sQ := sQ / pi * 180;
    TextOut(50,120 + Ycont,'  (px)@' + floatTostr(sQ) + ' ');
    TextOut(50,140 + Ycont,'f́@' + floatTostr(tau));
    TextOut(50,160 + Ycont,'gN@  ' + floatTostr(T) + ' Nmm');
  end;
end;

procedure TMainF.Image1DblClick(Sender: TObject);
begin
  dispF := False;
  KDisp;//W\
  Image1.Canvas.Font.Height := 15;
  Image1.Canvas.Font.Color:= Clred;
  Image1.Canvas.TextOut(230, 200 + Yposd,'`fʂ̂˂W');
end;

procedure TMainF.abcalcClick(Sender: TObject);
var
  abratio: double;
  I, check: integer;
begin
  dispF := True;
  clear;
  disp;
  MessDisp;//Rg\
  with Image1.Canvas do begin
    Font.Height := 15;
    Font.Color := clRed;
    if FloatCheck(Lengthin.Text) <> 0 then
        begin
          TextOut(30,180 + Yposd,'pg[Vo[̒ɓ͊ԈႢ܂B');
          exit;
        end;
    if FloatCheck(torquein.Text) <> 0 then
        begin
          TextOut(30,180 + Yposd,'pg[Vo[̃gNɓ͊ԈႢ܂B');
          exit;
        end;
    if FloatCheck(Gdatain.Text) <> 0 then
        begin
          TextOut(30,180 + Yposd,'pg[Vo[̉eWɓ͊ԈႢ܂B');
          exit;
        end;
    if FloatCheck(asizein.Text) <> 0 then
        begin
          TextOut(30,180 + Yposd,'pg[Vo[́Afʂ́Aɓ͊ԈႢ܂B');
          exit;
        end;
    if FloatCheck(bsizein.Text) <> 0 then
        begin
          TextOut(30,180 + Yposd,'pg[Vo[́Afʂ́Aɓ͊ԈႢ܂B');
          exit;
        end;
    clear;
    disp;
    val(Lengthin.Text, L, check);                            // ɓ̓f[^[̃`FbNĂ̂
    if check <> 0 then exit;                                 // ̍sɈӖ͂Ȃ
//    L := strToFloat(Lengthin.Text);                        // strToFloat()łǂ
//    val(torquein.Text, T, check);
//    if check <> 0 then exit;
    T := strToFloat(torquein.Text);
//    val(Gdatain.Text, G, check);
//    if check <> 0 then exit;
    G := strToFloat(Gdatain.Text);
//    val(asizein.Text, aleng, check);
//    if check <> 0 then exit;
    aLeng := strTofloat(asizein.Text);
//    val(bsizein.Text, bLeng, check);
//    if check <> 0 then exit;
    bLeng := strTofloat(bsizein.Text);
    if bLeng > aLeng then
      begin
        TextOut(30,180 + Yposd,'pg[Vo[́Afʂ̒A蒷ȂĂ܂B');
        exit;
      end;
    abratio := aLeng / bLeng;                                   // c
    if abratio >= 100 then                                      // c䂩璷`̃lWW擾
      begin
        K2D := 0.333;
        K3D := 0.333;
      end
      else
      begin
        for I := 0 to 33 do                                     // c䂩璷`̃lWW擾
          begin                                                 //
            if ba[I] > abratio then
              begin
                X1 := abratio - ba[I - 1];
                K2D := (K2[I] - K2[I - 1]) / (ba[I] - ba[I - 1]) * X1 + K2[I - 1];
                K3D := (K3[I] - K3[I - 1]) / (ba[I] - ba[I - 1]) * X1 + K3[I - 1];
                break;
              end;
          end;
      end;
    KDisp;//W\
    if abratio > 20 then abratio := 20;
    Xpos := round(Xscale * abratio) + Xbase;
    Ypos := Ybase - round(Yscale * K2D);
    Pen.Color := clRed;
    Pen.Width := 2;
    Ellipse(Xpos - 3, Ypos - 3, Xpos + 3, Ypos + 3);
    Ypos := Ybase - round(Yscale * K3D);
    Pen.Color := clBlue;
    Ellipse(Xpos - 2, Ypos - 2, Xpos + 2, Ypos + 2);

    sQ := T * L / k2d / aLeng / power(bLeng, 3) / G;             // lWp radian
    tau := T / k3d / aLeng / power(bLeng, 2);                    // f
    Font.Height := 15;
    TextOut(300,280,'݊p@' + floatTostr(sQ) + ' rad');
    sQ := sQ / pi * 180;                                         // lWp 
    TextOut(300,300,'  (px)@' + floatTostr(sQ) + ' ');
    TextOut(300,320,'f́@' + floatTostr(tau));
  end;
end;

procedure TMainF.DiaCalcBClick(Sender: TObject);
var
  check: integer;
begin
  clear;
  disp;
  MessDisp;//Rg\
  with Image1.Canvas do begin
    Font.Height := 15;
    Font.Color := clRed;
    if FloatCheck(Lengthin.Text) <> 0 then
      begin
        TextOut(30,180 + Yposd,'ێg[Vo[̒ɓ͊ԈႢ܂B');
        exit;
      end;
    if FloatCheck(torquein.Text) <> 0 then
      begin
        TextOut(30,180 + Yposd,'ێg[Vo[̃gNɓ͊ԈႢ܂B');
        exit;
      end;
    if FloatCheck(Diain.Text) <> 0 then
      begin
        TextOut(30,180 + Yposd,'ێg[Vo[̒aɓ͊ԈႢ܂B');
        exit;
      end;
    if FloatCheck(Diaind1.Text) <> 0 then
      begin
        TextOut(30,180 + Yposd,'ێg[Vo[̓aɓ͊ԈႢ܂B');
        exit;
      end;
    if FloatCheck(Gdatain.Text) <> 0 then
      begin
        TextOut(30,180 + Yposd,'ێg[Vo[̉eWɓ͊ԈႢ܂B');
        exit;
      end;
    clear;
    disp;
//    Val(Lengthin.Text,L,check);
//    if check <> 0 then exit;
    L := strToFloat(Lengthin.Text);
    Val(torquein.Text,T,check);
    if check <> 0 then exit;
//    T := strToFloat(torquein.Text);
    Val(Diain.Text,d2,check);
    if check <> 0 then exit;
//    d2 := strToFloat(Diain.Text);
    Val(Diaind1.Text,d1,check);
    if check <> 0 then exit;
//    d1 := strToFloat(Diaind1.Text);
    if d2 <= d1 then
      begin
        TextOut(30,180 + Yposd,'ێ̊Oaa傫ÂŌvZo܂B');
        exit;
      end;
    Val(Gdatain.Text,G,check);
    if check <> 0 then exit;
//    G := strToFloat(Gdatain.Text);
    sQ := 32 * T * L / pi / (power(d2, 4) - power(d1, 4)) / G;           // lWp
    tau := sQ * d2 * G / 2 / L;                                          // f
    Font.Color := clblack;
    Font.Height := 15;
    TextOut(110,180 + Yposd,'݊p@' + floatTostr(sQ) + ' rad');    // lWp radian \
    sQ := sQ / pi * 180;
    TextOut(110,200 + Yposd,'  (px)@' + floatTostr(sQ) + ' ');      // lWp \
    TextOut(110,220 + Yposd,'f́@' + floatTostr(tau));            // f͕\
  end;
end;

procedure TMainF.ComboBoxChange(Sender: TObject);
begin
  Gdatain.Text := ItemG[ComboBox.ItemIndex];
end;

procedure TMainF.GdatainKeyPress(Sender: TObject; var Key: Char);
begin
  ComboBox.Text := '';
end;

procedure TMainF.LengthinChange(Sender: TObject);
begin
  clear;
  disp;
  MessDisp;//Rg\
end;

procedure TMainF.torqueinChange(Sender: TObject);
begin
  clear;
  disp;
  MessDisp;//Rg\
end;

procedure TMainF.GdatainChange(Sender: TObject);
begin
  clear;
  disp;
  MessDisp;//Rg\
end;

procedure TMainF.DiainChange(Sender: TObject);
begin
  clear;
  disp;
  MessDisp;//Rg\
end;

procedure TMainF.diaind1Change(Sender: TObject);
begin
  clear;
  disp;
  MessDisp;//Rg\
end;

procedure TMainF.asizeinChange(Sender: TObject);
begin
  clear;
  disp;
  MessDisp;//Rg\
end;

procedure TMainF.bsizeinChange(Sender: TObject);
begin
  clear;
  disp;
  MessDisp;//Rg\
end;

end.
